// MFCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCDemo.h"
#include "MFCDemoDlg.h"

#pragma comment(lib, "BarcodeWin32.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

extern "C" __declspec(dllimport) void _stdcall BCConfigure(WORD SymbologyType, double BarHeight, double NarrowBarWidth, double Wide2NarrowRatio, WORD Orientation, double BorderWidth);
extern "C" __declspec(dllimport) void _stdcall BCCodaBarInfo(WORD StartChar, WORD EndChar);
extern "C" __declspec(dllimport) BOOL  _stdcall BCCopyToClipboard();
extern "C" __declspec(dllimport) void _stdcall BCFontInfo(LPCTSTR FontName, WORD FontSize, BOOL Bold, BOOL Italic);
extern "C" __declspec(dllimport) void _stdcall BCRender(HDC hDC, WORD x, WORD y);

extern "C" __declspec(dllimport) BOOL _stdcall BCSaveAsBMP(LPCTSTR FileName);
extern "C" __declspec(dllimport) BOOL _stdcall BCSaveAsWMF(LPCTSTR FileName);
extern "C" __declspec(dllimport) void _stdcall BCSetBackColor(WORD red, WORD green, WORD blue);
extern "C" __declspec(dllimport) void _stdcall BCSetBarColor(WORD red, WORD green, WORD blue);
extern "C" __declspec(dllimport) void _stdcall BCSetDefault();
extern "C" __declspec(dllimport) void _stdcall BCSetMessage(LPCTSTR message);
extern "C" __declspec(dllimport) void _stdcall BCSetSize(WORD Width, WORD Height);
extern "C" __declspec(dllimport) void _stdcall BCSupplementInfo(WORD SupplementType, LPCTSTR Supplement, double Separation);
extern "C" __declspec(dllimport) void _stdcall BCTextInfo(BOOL ShowText, BOOL CheckDigit, BOOL CheckDigitToText);
extern "C" __declspec(dllimport) void _stdcall BCUPCESystem(WORD SystemType);
extern "C" __declspec(dllimport) void _stdcall BCGetActualSize(BOOL ScreenIsTarget, DWORD TargetHDC, DWORD *ActualWidth, DWORD *ActualHeight);

extern "C" __declspec(dllimport) void _stdcall BCMicroQRCode(WORD version, WORD level);
extern "C" __declspec(dllimport) void _stdcall BCMicroPDF417(WORD columns);
extern "C" __declspec(dllimport) void _stdcall BCCodeOne(WORD version);
extern "C" __declspec(dllimport) void _stdcall BCBearerBar(WORD style);
extern "C" __declspec(dllimport) void _stdcall BCSet2ndMessage(LPCTSTR SecondMessage);

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCDemoDlg dialog

CMFCDemoDlg::CMFCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFCDemoDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CMFCDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PRINT, OnButtonPrint)
	ON_BN_CLICKED(IDC_BUTTON_BMP, OnButtonBmp)
	ON_BN_CLICKED(IDC_BUTTON_WMF, OnButtonWmf)
	ON_BN_CLICKED(IDC_BUTTON_COPY, OnButtonCopy)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCDemoDlg message handlers

BOOL CMFCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CMFCDemoDlg::OnButtonPrint() 
{
	// TODO: Add your control notification handler code here
	DWORD ActualWidth, ActualHeight;
	HDC hPrinterDC;

    // get the "Printer Dialog"
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // do the initialization 
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;

    // show the "Printer Dialog"
    printerDlg->DoModal();

    // get the handle of printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL)
    {
		CDC *pDC = new CDC;
		// attach the printer DC
        pDC->Attach(hPrinterDC);     

		// start a new print job
        pDC->StartDoc("sample barcode");  
                                 
		// start a new page
        pDC->StartPage();

		// choose the default configurations for the barcode
		BCSetDefault();

		int BarcodeType = 18;
		int Orientation = 0;
		BCConfigure(BarcodeType, 2.5, 0.08, 2.2, Orientation, 0.03);

		// text message related info
		BCTextInfo(TRUE, FALSE, FALSE);
    
		// font info
		BCFontInfo("Arial", 16, FALSE, FALSE);

		// get the actual barcode width and height
		// render a barcode onto printer
		BCGetActualSize(FALSE, (DWORD)hPrinterDC, &ActualWidth, &ActualHeight);

		// image size = barcode size + extra space
		if ((Orientation == 0) || (Orientation == 2))
			BCSetSize(ActualWidth + 300, ActualHeight + 400);
		else
			BCSetSize(ActualHeight + 400, ActualWidth + 300);

		// The barcode is printed at the point (100, 500)
		// (x = 100, y = 500)
		BCRender(pDC->m_hDC, 100, 500);

		// end the current page
        pDC->EndPage();            

		// end the current print job
        pDC->EndDoc();    
		
		// detach the printer DC
        pDC->Detach();
		
        delete pDC;
	}

    delete printerDlg;
}

void CMFCDemoDlg::OnButtonBmp() 
{
	// TODO: Add your control notification handler code here
	DWORD ActualWidth, ActualHeight;
	
	// choose the default configurations for the barcode
    BCSetDefault();
    
    // message
    BCSetMessage("12345678");
    
    // bar color
    BCSetBarColor(255, 0, 0);
    
    // background color
    BCSetBackColor(255, 255, 255);
    
    int BarcodeType = 4;
	int Orientation = 1;
    BCConfigure(BarcodeType, 2.5, 0.08, 2.2, Orientation, 0.03);
    
    // text message related info
    BCTextInfo(TRUE, FALSE, FALSE);
    
    // font info
    BCFontInfo("Arial", 20, FALSE, FALSE);
    
    // if you are using the supplement, provide the supplement info here
    // otherwise ignore this line
    BCSupplementInfo(1, "12", 0.6);
    
    // if you are using CodeBar, provide CodeBar related info here
    // otherwise ignore this line
    BCCodaBarInfo(0, 1);
    
    // if you are using UPCE barcode, provide UPCE info here
    // otherwise ignore this line
    BCUPCESystem(0);

	// get the actual barcode width and height
    // render a barcode onto computer screen
	BCGetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	// image size = barcode size + extra space
	if ((Orientation == 0) || (Orientation == 2))
		BCSetSize(ActualWidth + 300, ActualHeight + 400);
	else
		BCSetSize(ActualHeight + 400, ActualWidth + 300);
    
    BCSaveAsBMP("c:\\BC.bmp");
}

void CMFCDemoDlg::OnButtonWmf() 
{
	// TODO: Add your control notification handler code here
	DWORD ActualWidth, ActualHeight;
	
	// choose the default configurations for the barcode
    BCSetDefault();
    
    // message
    BCSetMessage("12567");
    
    // bar color
    BCSetBarColor(0, 0, 0);
    
    // background color
    BCSetBackColor(255, 255, 255);
    
	int BarcodeType = 18;
	int Orientation = 0;
    BCConfigure(BarcodeType, 2.5, 0.08, 2.2, Orientation, 0.03);
    
    // text message related info
    BCTextInfo(TRUE, FALSE, FALSE);
    
    // font info
    BCFontInfo("Arial", 16, FALSE, TRUE);
    
    // if you are using the supplement, provide the supplement info here
    // otherwise ignore this line
    BCSupplementInfo(1, "12", 0.6);
    
	if (BarcodeType == 2)
	{
        // CodeBar
        BCCodaBarInfo(0, 1);
	}
    else if (BarcodeType == 58)
	{
        // UPC-E
        BCUPCESystem(1);
	}
    else if (BarcodeType == 25)
	{
        // GS1 Databar 14 Composite
        BCSet2ndMessage("This is the secondary message");
	}
    else if (BarcodeType == 37)
	{
        // Interleaved 2 0f 5
        BCBearerBar(1);
	}
    else if (BarcodeType == 89)
	{
        // Code One
        BCCodeOne(2);
	}
    else if (BarcodeType == 90)
	{
        // Micro PDF417
        BCMicroPDF417(4);
	}
    else if (BarcodeType == 91)
	{
        // Micro QRCode
        BCMicroQRCode(3, 2);
    }

	// get the actual barcode width and height
    // render a barcode onto computer screen
	BCGetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	// image size = barcode size + extra space
	if ((Orientation == 0) || (Orientation == 2))
		BCSetSize(ActualWidth + 35, ActualHeight + 55);
	else
		BCSetSize(ActualHeight + 55, ActualWidth + 35);
    
    BCSaveAsWMF("c:\\BC.wmf");
}

void CMFCDemoDlg::OnButtonCopy() 
{
	// TODO: Add your control notification handler code here
	DWORD ActualWidth, ActualHeight;
	
	// choose the default configurations for the barcode
    BCSetDefault();

	// message
    BCSetMessage("1234567");

	// get the actual barcode width and height
    // render a barcode on the computer screen
	BCGetActualSize(TRUE, NULL, &ActualWidth, &ActualHeight);

	// image size = barcode size + extra space
	BCSetSize(ActualWidth + 40, ActualHeight + 60);
    
    // send the image to the clipboard
    BCCopyToClipboard();
}

void CMFCDemoDlg::OnButtonExit() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}